--
-- PostgreSQL database dump
--

-- Started on 2008-01-07 02:09:25

SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

--
-- TOC entry 1708 (class 1262 OID 16403)
-- Name: SDA_KB; Type: DATABASE; Schema: -; Owner: postgres
--

CREATE DATABASE "SDA_KB" WITH TEMPLATE = template0 ENCODING = 'UTF8';


ALTER DATABASE "SDA_KB" OWNER TO postgres;

\connect "SDA_KB"

SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

--
-- TOC entry 1709 (class 0 OID 0)
-- Dependencies: 5
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: postgres
--

COMMENT ON SCHEMA public IS 'Standard public schema';


--
-- TOC entry 306 (class 2612 OID 16571)
-- Name: plpgsql; Type: PROCEDURAL LANGUAGE; Schema: -; Owner: postgres
--

CREATE PROCEDURAL LANGUAGE plpgsql;


SET search_path = public, pg_catalog;

--
-- TOC entry 276 (class 1247 OID 16573)
-- Dependencies: 1311
-- Name: res_sp_fdm_getdemandfact; Type: TYPE; Schema: public; Owner: postgres
--

CREATE TYPE res_sp_fdm_getdemandfact AS (
	"dateId" integer,
	"productId" integer,
	"cicQueryCount" integer,
	"shopsSellingCount" integer,
	"registeredClients" integer
);


ALTER TYPE public.res_sp_fdm_getdemandfact OWNER TO postgres;

--
-- TOC entry 277 (class 1247 OID 16575)
-- Dependencies: 1312
-- Name: res_sp_fsa_getsalesfact; Type: TYPE; Schema: public; Owner: postgres
--

CREATE TYPE res_sp_fsa_getsalesfact AS (
	"negotiationEndDateId" integer,
	"negotiationEndTimeId" integer,
	"productId" integer,
	"strategyId" integer,
	"templateId" integer,
	"negotiationId" integer,
	"quantityOffered" integer,
	"valueOffered" numeric(12,2),
	"minValueOffered" numeric(12,2),
	"quantityReserved" integer,
	"valueReserved" numeric(12,2),
	"quantityConfirmed" integer,
	"valueConfirmed" numeric(12,2),
	"bidCount" integer,
	"winningBidCount" integer,
	"finishedTransactionCount" integer
);


ALTER TYPE public.res_sp_fsa_getsalesfact OWNER TO postgres;

--
-- TOC entry 278 (class 1247 OID 16577)
-- Dependencies: 1313
-- Name: res_sp_fsp_getsuppliesfact; Type: TYPE; Schema: public; Owner: postgres
--

CREATE TYPE res_sp_fsp_getsuppliesfact AS (
	wholesalerid integer,
	productid integer,
	orderdateid integer,
	ordertimeid integer,
	deliverydateid integer,
	deliverytimeid integer,
	quantityordered integer,
	valueordered numeric(12,2),
	quantitydelivered integer,
	valuedelivered numeric(12,2)
);


ALTER TYPE public.res_sp_fsp_getsuppliesfact OWNER TO postgres;

--
-- TOC entry 18 (class 1255 OID 16578)
-- Dependencies: 306 5
-- Name: sp_ddt_getdatekey(date); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_ddt_getdatekey(fulldate date) RETURNS integer
    AS $$
DECLARE 
	dateid INTEGER;
BEGIN
	dateid := ddt_id FROM dim_date WHERE ddt_fulldate = fulldate;
	RETURN dateid;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.sp_ddt_getdatekey(fulldate date) OWNER TO postgres;

--
-- TOC entry 1711 (class 0 OID 0)
-- Dependencies: 18
-- Name: FUNCTION sp_ddt_getdatekey(fulldate date); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_ddt_getdatekey(fulldate date) IS 'Returns the surrogate key of the record in the date dimension corresponding to the given date. If no such record exists null is returned.';


--
-- TOC entry 19 (class 1255 OID 16579)
-- Dependencies: 5 306
-- Name: sp_ddt_insertdate(date, character varying, smallint, integer, integer, integer, smallint, smallint, smallint, smallint, integer, smallint, character varying); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_ddt_insertdate(fulldate date, dayofweek character varying, daynoinweek smallint, dayinepoch integer, weekinepoch integer, monthinepoch integer, dayinyear smallint, weekinyear smallint, monthinyear smallint, quarterinyear smallint, yearinepoch integer, dayinmonth smallint, weekdayindicator character varying) RETURNS integer
    AS $$
DECLARE 
	dateid INTEGER;
BEGIN
	INSERT INTO dim_date(ddt_fulldate, ddt_dayofweek, ddt_daynoinweek, ddt_dayinepoch, ddt_weekinepoch, ddt_monthinepoch, ddt_dayinyear,
		ddt_weekinyear, ddt_monthinyear, ddt_quarterinyear, ddt_year, ddt_dayinmonth, ddt_weekdayind) 
	VALUES( fullDate, dayOfWeek, dayNoInWeek, dayInEpoch, weekInEpoch, 
	monthInEpoch, dayInYear, weekInYear, monthInYear, quarterInYear, yearInEpoch,
	dayInMonth, weekdayIndicator);
	dateid = currval('dim_date_ddt_id_seq');
				
	RETURN dateid;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.sp_ddt_insertdate(fulldate date, dayofweek character varying, daynoinweek smallint, dayinepoch integer, weekinepoch integer, monthinepoch integer, dayinyear smallint, weekinyear smallint, monthinyear smallint, quarterinyear smallint, yearinepoch integer, dayinmonth smallint, weekdayindicator character varying) OWNER TO postgres;

--
-- TOC entry 1712 (class 0 OID 0)
-- Dependencies: 19
-- Name: FUNCTION sp_ddt_insertdate(fulldate date, dayofweek character varying, daynoinweek smallint, dayinepoch integer, weekinepoch integer, monthinepoch integer, dayinyear smallint, weekinyear smallint, monthinyear smallint, quarterinyear smallint, yearinepoch integer, dayinmonth smallint, weekdayindicator character varying); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_ddt_insertdate(fulldate date, dayofweek character varying, daynoinweek smallint, dayinepoch integer, weekinepoch integer, monthinepoch integer, dayinyear smallint, weekinyear smallint, monthinyear smallint, quarterinyear smallint, yearinepoch integer, dayinmonth smallint, weekdayindicator character varying) IS 'Inserts a new entry into the date dimension and returns the surrogate key of the newly added entry.';


--
-- TOC entry 20 (class 1255 OID 16580)
-- Dependencies: 306 5
-- Name: sp_dpd_getproductkey(character varying); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_dpd_getproductkey(globalid character varying) RETURNS integer
    AS $$
DECLARE 
	id INTEGER;
BEGIN
	id := dpd_id FROM dim_product WHERE dpd_globalproductid = globalid;
	RETURN id;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.sp_dpd_getproductkey(globalid character varying) OWNER TO postgres;

--
-- TOC entry 1713 (class 0 OID 0)
-- Dependencies: 20
-- Name: FUNCTION sp_dpd_getproductkey(globalid character varying); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_dpd_getproductkey(globalid character varying) IS 'Returns the surrogate key of the record in the product dimension corresponding to the given product. If no such record exists null is returned.';


--
-- TOC entry 21 (class 1255 OID 16581)
-- Dependencies: 5 306
-- Name: sp_dpd_insertproduct(character varying); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_dpd_insertproduct(globalid character varying) RETURNS integer
    AS $$
DECLARE 
	id INTEGER;
BEGIN
	INSERT INTO dim_product(dpd_globalproductid) VALUES( globalid);
	id = currval('dim_product_dpd_id_seq');
				
	RETURN id;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.sp_dpd_insertproduct(globalid character varying) OWNER TO postgres;

--
-- TOC entry 1714 (class 0 OID 0)
-- Dependencies: 21
-- Name: FUNCTION sp_dpd_insertproduct(globalid character varying); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_dpd_insertproduct(globalid character varying) IS 'Inserts a new entry into the product dimension and returns the surrogate key of the newly added entry.';


--
-- TOC entry 22 (class 1255 OID 16582)
-- Dependencies: 5 306
-- Name: sp_dst_getstrategykey(character varying); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_dst_getstrategykey(globalid character varying) RETURNS integer
    AS $$
DECLARE 
	id INTEGER;
BEGIN
	id := dst_id FROM dim_strategy WHERE dst_globalid = globalid;
	RETURN id;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.sp_dst_getstrategykey(globalid character varying) OWNER TO postgres;

--
-- TOC entry 1715 (class 0 OID 0)
-- Dependencies: 22
-- Name: FUNCTION sp_dst_getstrategykey(globalid character varying); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_dst_getstrategykey(globalid character varying) IS 'Returns the surrogate key of the record in the strategy dimension corresponding to the given strategy. If no such record exists null is returned.';


--
-- TOC entry 23 (class 1255 OID 16583)
-- Dependencies: 5 306
-- Name: sp_dst_insertstrategy(character varying, character varying); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_dst_insertstrategy(globalid character varying, description character varying) RETURNS integer
    AS $$
DECLARE 
	id INTEGER;
BEGIN
	INSERT INTO dim_strategy(dst_globalid, dst_description) VALUES( globalid, description);
	id = currval('dim_strategy_dst_id_seq');
				
	RETURN id;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.sp_dst_insertstrategy(globalid character varying, description character varying) OWNER TO postgres;

--
-- TOC entry 1716 (class 0 OID 0)
-- Dependencies: 23
-- Name: FUNCTION sp_dst_insertstrategy(globalid character varying, description character varying); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_dst_insertstrategy(globalid character varying, description character varying) IS 'Inserts a new entry into the strategy dimension and returns the surrogate key of the newly added entry.';


--
-- TOC entry 24 (class 1255 OID 16584)
-- Dependencies: 306 5
-- Name: sp_dtm_gettimekey(time without time zone); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_dtm_gettimekey(fulltime time without time zone) RETURNS integer
    AS $$
DECLARE 
	timeid INTEGER;
BEGIN
	timeid := dtm_id FROM dim_time WHERE dtm_fulltime = fulltime;
	RETURN timeid;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.sp_dtm_gettimekey(fulltime time without time zone) OWNER TO postgres;

--
-- TOC entry 1717 (class 0 OID 0)
-- Dependencies: 24
-- Name: FUNCTION sp_dtm_gettimekey(fulltime time without time zone); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_dtm_gettimekey(fulltime time without time zone) IS 'Returns the surrogate key of the record in the time dimension corresponding to the given time of day. If no such record exists null is returned.';


--
-- TOC entry 25 (class 1255 OID 16585)
-- Dependencies: 306 5
-- Name: sp_dtm_inserttime(time without time zone, smallint, character varying); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_dtm_inserttime(fulltime time without time zone, hourpart smallint, ampmindicator character varying) RETURNS integer
    AS $$
DECLARE 
	timeid INTEGER;
BEGIN
	INSERT INTO dim_time(dtm_fulltime, dtm_hour, dtm_ampmind) VALUES( fullTime, hourpart, ampmindicator);
	timeid = currval('dim_time_dtm_id_seq');
				
	RETURN timeid;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.sp_dtm_inserttime(fulltime time without time zone, hourpart smallint, ampmindicator character varying) OWNER TO postgres;

--
-- TOC entry 1718 (class 0 OID 0)
-- Dependencies: 25
-- Name: FUNCTION sp_dtm_inserttime(fulltime time without time zone, hourpart smallint, ampmindicator character varying); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_dtm_inserttime(fulltime time without time zone, hourpart smallint, ampmindicator character varying) IS 'Inserts a new entry into the time dimension and returns the surrogate key of the newly added entry.';


--
-- TOC entry 26 (class 1255 OID 16586)
-- Dependencies: 306 5
-- Name: sp_dtmp_gettemplatekey(character varying); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_dtmp_gettemplatekey(globalid character varying) RETURNS integer
    AS $$
DECLARE 
	id INTEGER;
BEGIN
	id := dtmp_id FROM dim_template WHERE dtmp_globalid = globalid;
	RETURN id;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.sp_dtmp_gettemplatekey(globalid character varying) OWNER TO postgres;

--
-- TOC entry 1719 (class 0 OID 0)
-- Dependencies: 26
-- Name: FUNCTION sp_dtmp_gettemplatekey(globalid character varying); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_dtmp_gettemplatekey(globalid character varying) IS 'Returns the surrogate key of the record in the template dimension corresponding to the given template. If no such record exists null is returned.';


--
-- TOC entry 27 (class 1255 OID 16587)
-- Dependencies: 306 5
-- Name: sp_dtmp_inserttemplate(character varying, character varying); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_dtmp_inserttemplate(globalid character varying, description character varying) RETURNS integer
    AS $$
DECLARE 
	id INTEGER;
BEGIN
	INSERT INTO dim_template(dtmp_globalid, dtmp_description) VALUES( globalid, description);
	id = currval('dim_template_dtmp_id_seq');
				
	RETURN id;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.sp_dtmp_inserttemplate(globalid character varying, description character varying) OWNER TO postgres;

--
-- TOC entry 1720 (class 0 OID 0)
-- Dependencies: 27
-- Name: FUNCTION sp_dtmp_inserttemplate(globalid character varying, description character varying); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_dtmp_inserttemplate(globalid character varying, description character varying) IS 'Inserts a new entry into the template dimension and returns the surrogate key of the newly added entry.';


--
-- TOC entry 28 (class 1255 OID 16588)
-- Dependencies: 5 306
-- Name: sp_dwh_getwholesalerkey(character varying); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_dwh_getwholesalerkey(globalid character varying) RETURNS integer
    AS $$
DECLARE 
	id INTEGER;
BEGIN
	id := dwh_id FROM dim_wholesaler WHERE dwh_globalid = globalid;
	RETURN id;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.sp_dwh_getwholesalerkey(globalid character varying) OWNER TO postgres;

--
-- TOC entry 1721 (class 0 OID 0)
-- Dependencies: 28
-- Name: FUNCTION sp_dwh_getwholesalerkey(globalid character varying); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_dwh_getwholesalerkey(globalid character varying) IS 'Returns the surrogate key of the record in the wholesaler dimension corresponding to the given wholesaler. If no such record exists null is returned.';


--
-- TOC entry 30 (class 1255 OID 16589)
-- Dependencies: 306 5
-- Name: sp_dwh_insertwholesaler(character varying); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_dwh_insertwholesaler(globalid character varying) RETURNS integer
    AS $$
DECLARE 
	id INTEGER;
BEGIN
	INSERT INTO dim_wholesaler(dwh_globalid) VALUES( globalid);
	id = currval('dim_wholesaler_dwh_id_seq');
				
	RETURN id;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.sp_dwh_insertwholesaler(globalid character varying) OWNER TO postgres;

--
-- TOC entry 1722 (class 0 OID 0)
-- Dependencies: 30
-- Name: FUNCTION sp_dwh_insertwholesaler(globalid character varying); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_dwh_insertwholesaler(globalid character varying) IS 'Inserts a new entry into the wholesaler dimension and returns the surrogate key of the newly added entry.';


--
-- TOC entry 31 (class 1255 OID 16590)
-- Dependencies: 276 5
-- Name: sp_fdm_getdemandfact(integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_fdm_getdemandfact(dateid integer, productid integer) RETURNS SETOF res_sp_fdm_getdemandfact
    AS $_$
	SELECT  "fdm_ddt_dateid" AS "dateId",
		"fdm_dpd_productid"  AS "productId",
		"fdm_cicquerycount" AS "cicQueryCount",
		"fdm_shopssellingcount" AS "shopsSellingCount",
		"fdm_registeredclients" AS "registeredClients"
	FROM ft_demand WHERE fdm_ddt_dateid = $1 AND fdm_dpd_productid = $2;
$_$
    LANGUAGE sql;


ALTER FUNCTION public.sp_fdm_getdemandfact(dateid integer, productid integer) OWNER TO postgres;

--
-- TOC entry 1723 (class 0 OID 0)
-- Dependencies: 31
-- Name: FUNCTION sp_fdm_getdemandfact(dateid integer, productid integer); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_fdm_getdemandfact(dateid integer, productid integer) IS 'Returns information describing the demand for the specified product on the specified date.';


--
-- TOC entry 32 (class 1255 OID 16591)
-- Dependencies: 5
-- Name: sp_fdm_insertdemandfact(integer, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_fdm_insertdemandfact("dateId" integer, "productId" integer, "cicQueryCount" integer, "shopsSellingCount" integer) RETURNS void
    AS $_$
	INSERT INTO ft_demand("fdm_ddt_dateid", 
		"fdm_dpd_productid", 
		"fdm_cicquerycount", 
		"fdm_shopssellingcount")
	VALUES( $1, $2, $3, $4);
$_$
    LANGUAGE sql;


ALTER FUNCTION public.sp_fdm_insertdemandfact("dateId" integer, "productId" integer, "cicQueryCount" integer, "shopsSellingCount" integer) OWNER TO postgres;

--
-- TOC entry 1724 (class 0 OID 0)
-- Dependencies: 32
-- Name: FUNCTION sp_fdm_insertdemandfact("dateId" integer, "productId" integer, "cicQueryCount" integer, "shopsSellingCount" integer); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_fdm_insertdemandfact("dateId" integer, "productId" integer, "cicQueryCount" integer, "shopsSellingCount" integer) IS 'Inserts information describing the demand for a product into the demand fact table.';


--
-- TOC entry 33 (class 1255 OID 16592)
-- Dependencies: 5
-- Name: sp_fdm_insertdemandfact(integer, integer, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_fdm_insertdemandfact("dateId" integer, "productId" integer, "cicQueryCount" integer, "shopsSellingCount" integer, "registeredClients" integer) RETURNS void
    AS $_$
	INSERT INTO ft_demand("fdm_ddt_dateid", 
		"fdm_dpd_productid", 
		"fdm_cicquerycount", 
		"fdm_shopssellingcount",
		"fdm_registeredclients")
	VALUES( $1, $2, $3, $4, $5);
$_$
    LANGUAGE sql;


ALTER FUNCTION public.sp_fdm_insertdemandfact("dateId" integer, "productId" integer, "cicQueryCount" integer, "shopsSellingCount" integer, "registeredClients" integer) OWNER TO postgres;

--
-- TOC entry 1725 (class 0 OID 0)
-- Dependencies: 33
-- Name: FUNCTION sp_fdm_insertdemandfact("dateId" integer, "productId" integer, "cicQueryCount" integer, "shopsSellingCount" integer, "registeredClients" integer); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_fdm_insertdemandfact("dateId" integer, "productId" integer, "cicQueryCount" integer, "shopsSellingCount" integer, "registeredClients" integer) IS 'Inserts information describing the demand for a product into the demand fact table.';


--
-- TOC entry 34 (class 1255 OID 16593)
-- Dependencies: 5
-- Name: sp_fdm_updatedemandfact(integer, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_fdm_updatedemandfact("dateId" integer, "productId" integer, "cicQueryCount" integer, "shopsSellingCount" integer) RETURNS void
    AS $_$
	UPDATE ft_demand SET "fdm_cicquerycount" = $3, 
		"fdm_shopssellingcount" = $4
	WHERE "fdm_ddt_dateid" = $1 AND "fdm_dpd_productid" = $2;
$_$
    LANGUAGE sql;


ALTER FUNCTION public.sp_fdm_updatedemandfact("dateId" integer, "productId" integer, "cicQueryCount" integer, "shopsSellingCount" integer) OWNER TO postgres;

--
-- TOC entry 1726 (class 0 OID 0)
-- Dependencies: 34
-- Name: FUNCTION sp_fdm_updatedemandfact("dateId" integer, "productId" integer, "cicQueryCount" integer, "shopsSellingCount" integer); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_fdm_updatedemandfact("dateId" integer, "productId" integer, "cicQueryCount" integer, "shopsSellingCount" integer) IS 'Updates information describing the demand for a product in the demand fact table.';


--
-- TOC entry 35 (class 1255 OID 16594)
-- Dependencies: 5
-- Name: sp_fdm_updatedemandfact(integer, integer, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_fdm_updatedemandfact("dateId" integer, "productId" integer, "cicQueryCount" integer, "shopsSellingCount" integer, "registeredClients" integer) RETURNS void
    AS $_$
	UPDATE ft_demand SET "fdm_cicquerycount" = $3, 
		"fdm_shopssellingcount" = $4,
		"fdm_registeredclients" = $5
	WHERE "fdm_ddt_dateid" = $1 AND "fdm_dpd_productid" = $2;
$_$
    LANGUAGE sql;


ALTER FUNCTION public.sp_fdm_updatedemandfact("dateId" integer, "productId" integer, "cicQueryCount" integer, "shopsSellingCount" integer, "registeredClients" integer) OWNER TO postgres;

--
-- TOC entry 1727 (class 0 OID 0)
-- Dependencies: 35
-- Name: FUNCTION sp_fdm_updatedemandfact("dateId" integer, "productId" integer, "cicQueryCount" integer, "shopsSellingCount" integer, "registeredClients" integer); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_fdm_updatedemandfact("dateId" integer, "productId" integer, "cicQueryCount" integer, "shopsSellingCount" integer, "registeredClients" integer) IS 'Updates information describing the demand for a product in the demand fact table.';


--
-- TOC entry 38 (class 1255 OID 16736)
-- Dependencies: 5
-- Name: sp_fdm_updatesuppliesfact(integer, integer, integer, integer, integer, integer, integer, real, integer, real); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_fdm_updatesuppliesfact(wholesalerid integer, productid integer, orderdateid integer, ordertimeid integer, deliverydateid integer, deliverytimeid integer, quantityordered integer, valueordered real, quantitydelivered integer, valuedelivered real) RETURNS void
    AS $_$
	UPDATE ft_supplies SET 
		"fsp_quantityordered" = $7,
		"fsp_valueordered" = $8,
		"fsp_quantitydelivered"= $9,
		"fsp_valuedelivered" = $10
	WHERE "fsp_dwh_wholesalerid" = $1 AND
		"fsp_dpd_productid"  = $2 AND
		"fsp_ddt_orderdateid" = $3 AND
		"fsp_dtm_ordertimeid" = $4 AND
		"fsp_ddt_deliverydateid" = $5 AND
		"fsp_dtm_deliverytimeid" = $6
$_$
    LANGUAGE sql;


ALTER FUNCTION public.sp_fdm_updatesuppliesfact(wholesalerid integer, productid integer, orderdateid integer, ordertimeid integer, deliverydateid integer, deliverytimeid integer, quantityordered integer, valueordered real, quantitydelivered integer, valuedelivered real) OWNER TO postgres;

--
-- TOC entry 1728 (class 0 OID 0)
-- Dependencies: 38
-- Name: FUNCTION sp_fdm_updatesuppliesfact(wholesalerid integer, productid integer, orderdateid integer, ordertimeid integer, deliverydateid integer, deliverytimeid integer, quantityordered integer, valueordered real, quantitydelivered integer, valuedelivered real); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_fdm_updatesuppliesfact(wholesalerid integer, productid integer, orderdateid integer, ordertimeid integer, deliverydateid integer, deliverytimeid integer, quantityordered integer, valueordered real, quantitydelivered integer, valuedelivered real) IS 'Updates information describing the supply order in the supply fact table.';


--
-- TOC entry 36 (class 1255 OID 16596)
-- Dependencies: 5 277
-- Name: sp_fsa_getsalesfact(integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_fsa_getsalesfact(negotiationid integer) RETURNS SETOF res_sp_fsa_getsalesfact
    AS $_$
	SELECT  "fsa_ddt_negoenddateid" AS "negotiationEndDateId",
		"fsa_dtm_negoendtimeid"  AS "negotiationEndTimeId",
		"fsa_dpd_productid" AS "productId",
		"fsa_dst_strategyid" AS "strategyId",		
		"fsa_dtmp_templateid" AS "templateId",
		"fsa_negotiationid" AS "negotiationId",
		"fsa_quantityoffered" AS "quantityOffered",		
		"fsa_valueoffered" AS "valueOffered",
		"fsa_minvalueoffered" AS "minValueOffered",
		"fsa_quantityreserved" AS "quantityReserved",
		"fsa_valuereserved" AS "valueReserved",
		"fsa_quantityconfirmed" AS "quantityConfirmed",
		"fsa_valueconfirmed" AS "valueConfirmed",
		"fsa_bidcount" AS "bidCount", 
		"fsa_winningbidcount" AS "winningBidCount",
		"fsa_finishedtransactioncount" AS "finishedTransactionCount"
	FROM ft_sales WHERE fsa_negotiationid = $1;	
$_$
    LANGUAGE sql;


ALTER FUNCTION public.sp_fsa_getsalesfact(negotiationid integer) OWNER TO postgres;

--
-- TOC entry 1729 (class 0 OID 0)
-- Dependencies: 36
-- Name: FUNCTION sp_fsa_getsalesfact(negotiationid integer); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_fsa_getsalesfact(negotiationid integer) IS 'Returns information describing the negotiation identified by the specified negotiation id.';


--
-- TOC entry 37 (class 1255 OID 16597)
-- Dependencies: 5
-- Name: sp_fsa_insertsalesfact(integer, integer, integer, integer, integer, integer, integer, real, real, integer, real, integer, real, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_fsa_insertsalesfact("negotiationEndDateId" integer, "negotiationEndTimeId" integer, "productId" integer, "strategyId" integer, "templateId" integer, "negotiationId" integer, "quantityOffered" integer, "valueOffered" real, "minValueOffered" real, "quantityReserved" integer, "valueReserved" real, "quantityConfirmed" integer, "valueConfirmed" real, "bidCount" integer, "winningBidCount" integer, "finishedTransactionCount" integer) RETURNS void
    AS $_$
	INSERT INTO ft_sales("fsa_ddt_negoenddateid", 
		"fsa_dtm_negoendtimeid", 
		"fsa_dpd_productid", 
		"fsa_dst_strategyid", 
		"fsa_dtmp_templateid",
		"fsa_negotiationid",
		"fsa_quantityoffered",
		"fsa_valueoffered",
		"fsa_minvalueoffered",
		"fsa_quantityreserved",
		"fsa_valuereserved",
		"fsa_quantityconfirmed",
		"fsa_valueconfirmed",
		"fsa_bidcount", 
		"fsa_winningbidcount",
		"fsa_finishedtransactioncount")
	VALUES( $1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16);
$_$
    LANGUAGE sql;


ALTER FUNCTION public.sp_fsa_insertsalesfact("negotiationEndDateId" integer, "negotiationEndTimeId" integer, "productId" integer, "strategyId" integer, "templateId" integer, "negotiationId" integer, "quantityOffered" integer, "valueOffered" real, "minValueOffered" real, "quantityReserved" integer, "valueReserved" real, "quantityConfirmed" integer, "valueConfirmed" real, "bidCount" integer, "winningBidCount" integer, "finishedTransactionCount" integer) OWNER TO postgres;

--
-- TOC entry 1730 (class 0 OID 0)
-- Dependencies: 37
-- Name: FUNCTION sp_fsa_insertsalesfact("negotiationEndDateId" integer, "negotiationEndTimeId" integer, "productId" integer, "strategyId" integer, "templateId" integer, "negotiationId" integer, "quantityOffered" integer, "valueOffered" real, "minValueOffered" real, "quantityReserved" integer, "valueReserved" real, "quantityConfirmed" integer, "valueConfirmed" real, "bidCount" integer, "winningBidCount" integer, "finishedTransactionCount" integer); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_fsa_insertsalesfact("negotiationEndDateId" integer, "negotiationEndTimeId" integer, "productId" integer, "strategyId" integer, "templateId" integer, "negotiationId" integer, "quantityOffered" integer, "valueOffered" real, "minValueOffered" real, "quantityReserved" integer, "valueReserved" real, "quantityConfirmed" integer, "valueConfirmed" real, "bidCount" integer, "winningBidCount" integer, "finishedTransactionCount" integer) IS 'Inserts information describing the negotiation into the sales fact table.';


--
-- TOC entry 41 (class 1255 OID 16734)
-- Dependencies: 5
-- Name: sp_fsa_updatesalesfact(integer, integer, integer, integer, integer, integer, integer, real, real, integer, real, integer, real, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_fsa_updatesalesfact("negotiationEndDateId" integer, "negotiationEndTimeId" integer, "productId" integer, "strategyId" integer, "templateId" integer, "negotiationId" integer, "quantityOffered" integer, "valueOffered" real, "minValueOffered" real, "quantityReserved" integer, "valueReserved" real, "quantityConfirmed" integer, "valueConfirmed" real, "bidCount" integer, "winningBidCount" integer, "finishedTransactionCount" integer) RETURNS void
    AS $_$
	UPDATE ft_sales SET "fsa_ddt_negoenddateid" = $1, 
		"fsa_dtm_negoendtimeid" = $2, 
		"fsa_dpd_productid" = $3, 
		"fsa_dst_strategyid" = $4, 
		"fsa_dtmp_templateid" = $5,
		"fsa_negotiationid" = $6,
		"fsa_quantityoffered" = $7,
		"fsa_valueoffered" = $8,
		"fsa_minvalueoffered" = $9,
		"fsa_quantityreserved" = $10,
		"fsa_valuereserved" = $11,
		"fsa_quantityconfirmed" = $12,
		"fsa_valueconfirmed" = $13,
		"fsa_bidcount" = $14, 
		"fsa_winningbidcount" = $15,
		"fsa_finishedtransactioncount" = $16
	WHERE "fsa_negotiationid" = $6;
$_$
    LANGUAGE sql;


ALTER FUNCTION public.sp_fsa_updatesalesfact("negotiationEndDateId" integer, "negotiationEndTimeId" integer, "productId" integer, "strategyId" integer, "templateId" integer, "negotiationId" integer, "quantityOffered" integer, "valueOffered" real, "minValueOffered" real, "quantityReserved" integer, "valueReserved" real, "quantityConfirmed" integer, "valueConfirmed" real, "bidCount" integer, "winningBidCount" integer, "finishedTransactionCount" integer) OWNER TO postgres;

--
-- TOC entry 1731 (class 0 OID 0)
-- Dependencies: 41
-- Name: FUNCTION sp_fsa_updatesalesfact("negotiationEndDateId" integer, "negotiationEndTimeId" integer, "productId" integer, "strategyId" integer, "templateId" integer, "negotiationId" integer, "quantityOffered" integer, "valueOffered" real, "minValueOffered" real, "quantityReserved" integer, "valueReserved" real, "quantityConfirmed" integer, "valueConfirmed" real, "bidCount" integer, "winningBidCount" integer, "finishedTransactionCount" integer); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_fsa_updatesalesfact("negotiationEndDateId" integer, "negotiationEndTimeId" integer, "productId" integer, "strategyId" integer, "templateId" integer, "negotiationId" integer, "quantityOffered" integer, "valueOffered" real, "minValueOffered" real, "quantityReserved" integer, "valueReserved" real, "quantityConfirmed" integer, "valueConfirmed" real, "bidCount" integer, "winningBidCount" integer, "finishedTransactionCount" integer) IS 'Updates information describing the negotiation in the sales fact table.';


--
-- TOC entry 39 (class 1255 OID 16599)
-- Dependencies: 5
-- Name: sp_fsf_insertforecastfact(integer, integer, integer, real, real); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_fsf_insertforecastfact("startDateId" integer, "endDateId" integer, "productId" integer, quantity real, deviation real) RETURNS void
    AS $_$
	INSERT INTO ft_salesforecasts("fsf_ddt_startdateid", 
		"fsf_ddt_enddateid", 
		"fsf_dpd_productid", 
		"fsf_quantity",
		"fsf_deviation")
	VALUES( $1, $2, $3, $4, $5);
$_$
    LANGUAGE sql;


ALTER FUNCTION public.sp_fsf_insertforecastfact("startDateId" integer, "endDateId" integer, "productId" integer, quantity real, deviation real) OWNER TO postgres;

--
-- TOC entry 1732 (class 0 OID 0)
-- Dependencies: 39
-- Name: FUNCTION sp_fsf_insertforecastfact("startDateId" integer, "endDateId" integer, "productId" integer, quantity real, deviation real); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_fsf_insertforecastfact("startDateId" integer, "endDateId" integer, "productId" integer, quantity real, deviation real) IS 'Inserts information describing the forecast of sales of a product during the specified period into the sales forecast fact table.';


--
-- TOC entry 40 (class 1255 OID 16600)
-- Dependencies: 5 278
-- Name: sp_fsp_getsuppliesfact(integer, integer, integer, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_fsp_getsuppliesfact(wholesalerid integer, productid integer, orderdateid integer, ordertimeid integer, deliverydateid integer, deliverytimeid integer) RETURNS SETOF res_sp_fsp_getsuppliesfact
    AS $_$
	SELECT  "fsp_dwh_wholesalerid" AS "wholesalerId",
		"fsp_dpd_productid"  AS "productId",
		"fsp_ddt_orderdateid" AS "orderDateId",
		"fsp_dtm_ordertimeid" AS "orderTimeId",
		"fsp_ddt_deliverydateid" AS "deliveryDateId",
		"fsp_dtm_deliverytimeid" AS "deliveryTimeId",
		"fsp_quantityordered" AS "quantityOrdered",
		"fsp_valueordered" AS "valueOrdered",
		"fsp_quantitydelivered" AS "quantityDelivered",
		"fsp_valuedelivered" AS "valueDelivered"
	FROM ft_supplies WHERE fsp_dwh_wholesalerid = $1 AND fsp_dpd_productid = $2 AND fsp_ddt_orderdateid = $3 
		AND fsp_dtm_ordertimeid = $4 AND fsp_ddt_deliverydateid = $5 AND fsp_dtm_deliverytimeid = $6;
$_$
    LANGUAGE sql;


ALTER FUNCTION public.sp_fsp_getsuppliesfact(wholesalerid integer, productid integer, orderdateid integer, ordertimeid integer, deliverydateid integer, deliverytimeid integer) OWNER TO postgres;

--
-- TOC entry 1733 (class 0 OID 0)
-- Dependencies: 40
-- Name: FUNCTION sp_fsp_getsuppliesfact(wholesalerid integer, productid integer, orderdateid integer, ordertimeid integer, deliverydateid integer, deliverytimeid integer); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_fsp_getsuppliesfact(wholesalerid integer, productid integer, orderdateid integer, ordertimeid integer, deliverydateid integer, deliverytimeid integer) IS 'Returns information describing the supply order .';


--
-- TOC entry 42 (class 1255 OID 16735)
-- Dependencies: 5
-- Name: sp_fsp_insertsuppliesfact(integer, integer, integer, integer, integer, integer, integer, real, integer, real); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION sp_fsp_insertsuppliesfact(wholesalerid integer, productid integer, orderdateid integer, ordertimeid integer, deliverydateid integer, deliverytimeid integer, quantityordered integer, valueordered real, quantitydelivered integer, valuedelivered real) RETURNS void
    AS $_$
	INSERT INTO ft_supplies(fsp_dwh_wholesalerid, fsp_dpd_productid, fsp_ddt_orderdateid, fsp_dtm_ordertimeid,
		fsp_ddt_deliverydateid, fsp_dtm_deliverytimeid, fsp_quantityordered, fsp_valueordered, 
		fsp_quantitydelivered, fsp_valuedelivered)
	VALUES( $1, $2, $3, $4, $5, $6, $7, $8, $9, $10);
$_$
    LANGUAGE sql;


ALTER FUNCTION public.sp_fsp_insertsuppliesfact(wholesalerid integer, productid integer, orderdateid integer, ordertimeid integer, deliverydateid integer, deliverytimeid integer, quantityordered integer, valueordered real, quantitydelivered integer, valuedelivered real) OWNER TO postgres;

--
-- TOC entry 1734 (class 0 OID 0)
-- Dependencies: 42
-- Name: FUNCTION sp_fsp_insertsuppliesfact(wholesalerid integer, productid integer, orderdateid integer, ordertimeid integer, deliverydateid integer, deliverytimeid integer, quantityordered integer, valueordered real, quantitydelivered integer, valuedelivered real); Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON FUNCTION sp_fsp_insertsuppliesfact(wholesalerid integer, productid integer, orderdateid integer, ordertimeid integer, deliverydateid integer, deliverytimeid integer, quantityordered integer, valueordered real, quantitydelivered integer, valuedelivered real) IS 'Inserts information describing the supply order into the supplies fact table.';


SET default_tablespace = '';

SET default_with_oids = false;

--
-- TOC entry 1314 (class 1259 OID 16602)
-- Dependencies: 5
-- Name: dim_buyer; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE dim_buyer (
    dbu_id integer NOT NULL,
    dbu_globalid character varying(20)
);


ALTER TABLE public.dim_buyer OWNER TO postgres;

--
-- TOC entry 1735 (class 0 OID 0)
-- Dependencies: 1314
-- Name: TABLE dim_buyer; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON TABLE dim_buyer IS 'A dimension table describing a single client. Table prefix: dbu';


--
-- TOC entry 1736 (class 0 OID 0)
-- Dependencies: 1314
-- Name: COLUMN dim_buyer.dbu_id; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_buyer.dbu_id IS 'The table''s surrogate key.';


--
-- TOC entry 1737 (class 0 OID 0)
-- Dependencies: 1314
-- Name: COLUMN dim_buyer.dbu_globalid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_buyer.dbu_globalid IS 'The operational client global id.';


--
-- TOC entry 1315 (class 1259 OID 16604)
-- Dependencies: 5 1314
-- Name: dim_buyer_dbu_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE dim_buyer_dbu_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.dim_buyer_dbu_id_seq OWNER TO postgres;

--
-- TOC entry 1738 (class 0 OID 0)
-- Dependencies: 1315
-- Name: dim_buyer_dbu_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE dim_buyer_dbu_id_seq OWNED BY dim_buyer.dbu_id;


--
-- TOC entry 1316 (class 1259 OID 16606)
-- Dependencies: 5
-- Name: dim_date; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE dim_date (
    ddt_id integer NOT NULL,
    ddt_fulldate date,
    ddt_dayofweek character varying(9),
    ddt_daynoinweek smallint,
    ddt_dayinepoch integer,
    ddt_weekinepoch integer,
    ddt_monthinepoch integer,
    ddt_dayinyear smallint,
    ddt_weekinyear smallint,
    ddt_monthinyear smallint,
    ddt_quarterinyear smallint,
    ddt_year integer,
    ddt_dayinmonth smallint,
    ddt_weekdayind character varying(7)
);


ALTER TABLE public.dim_date OWNER TO postgres;

--
-- TOC entry 1739 (class 0 OID 0)
-- Dependencies: 1316
-- Name: TABLE dim_date; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON TABLE dim_date IS 'A dimension table describing a date exact to a single day. Table prefix: ddt';


--
-- TOC entry 1740 (class 0 OID 0)
-- Dependencies: 1316
-- Name: COLUMN dim_date.ddt_id; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_date.ddt_id IS 'The table''s surrogate key.';


--
-- TOC entry 1741 (class 0 OID 0)
-- Dependencies: 1316
-- Name: COLUMN dim_date.ddt_dayofweek; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_date.ddt_dayofweek IS 'Can equal any of the following:
Monday
Tuesday
Wednesday
Thursday
Friday
Saturday
Sunday';


--
-- TOC entry 1742 (class 0 OID 0)
-- Dependencies: 1316
-- Name: COLUMN dim_date.ddt_daynoinweek; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_date.ddt_daynoinweek IS 'The number of day in a week (1-7)';


--
-- TOC entry 1743 (class 0 OID 0)
-- Dependencies: 1316
-- Name: COLUMN dim_date.ddt_dayinepoch; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_date.ddt_dayinepoch IS 'The number of day in epoch (since 01.01.1970)';


--
-- TOC entry 1744 (class 0 OID 0)
-- Dependencies: 1316
-- Name: COLUMN dim_date.ddt_weekinepoch; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_date.ddt_weekinepoch IS 'The number of week in epoch (since 01.01.1970)';


--
-- TOC entry 1745 (class 0 OID 0)
-- Dependencies: 1316
-- Name: COLUMN dim_date.ddt_monthinepoch; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_date.ddt_monthinepoch IS 'The number of the month in epoch (since 01.01.1970)';


--
-- TOC entry 1746 (class 0 OID 0)
-- Dependencies: 1316
-- Name: COLUMN dim_date.ddt_dayinyear; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_date.ddt_dayinyear IS 'The number of the day in month.';


--
-- TOC entry 1747 (class 0 OID 0)
-- Dependencies: 1316
-- Name: COLUMN dim_date.ddt_weekinyear; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_date.ddt_weekinyear IS 'The week number in year.';


--
-- TOC entry 1748 (class 0 OID 0)
-- Dependencies: 1316
-- Name: COLUMN dim_date.ddt_monthinyear; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_date.ddt_monthinyear IS 'The number of the month in year.';


--
-- TOC entry 1749 (class 0 OID 0)
-- Dependencies: 1316
-- Name: COLUMN dim_date.ddt_quarterinyear; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_date.ddt_quarterinyear IS 'The quarter number in year.';


--
-- TOC entry 1750 (class 0 OID 0)
-- Dependencies: 1316
-- Name: COLUMN dim_date.ddt_year; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_date.ddt_year IS 'The year number AD';


--
-- TOC entry 1751 (class 0 OID 0)
-- Dependencies: 1316
-- Name: COLUMN dim_date.ddt_dayinmonth; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_date.ddt_dayinmonth IS 'The day number in month.';


--
-- TOC entry 1752 (class 0 OID 0)
-- Dependencies: 1316
-- Name: COLUMN dim_date.ddt_weekdayind; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_date.ddt_weekdayind IS 'The weekday indicator. Takes a value of ''Weekday'' or ''Weekend''.';


--
-- TOC entry 1317 (class 1259 OID 16608)
-- Dependencies: 5 1316
-- Name: dim_date_ddt_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE dim_date_ddt_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.dim_date_ddt_id_seq OWNER TO postgres;

--
-- TOC entry 1753 (class 0 OID 0)
-- Dependencies: 1317
-- Name: dim_date_ddt_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE dim_date_ddt_id_seq OWNED BY dim_date.ddt_id;


--
-- TOC entry 1318 (class 1259 OID 16610)
-- Dependencies: 5
-- Name: dim_product; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE dim_product (
    dpd_id integer NOT NULL,
    dpd_globalproductid character varying(20)
);


ALTER TABLE public.dim_product OWNER TO postgres;

--
-- TOC entry 1754 (class 0 OID 0)
-- Dependencies: 1318
-- Name: TABLE dim_product; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON TABLE dim_product IS 'A dimension table describing a product sold. Table prefix: dpd';


--
-- TOC entry 1755 (class 0 OID 0)
-- Dependencies: 1318
-- Name: COLUMN dim_product.dpd_id; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_product.dpd_id IS 'The table''s surrogate key.';


--
-- TOC entry 1756 (class 0 OID 0)
-- Dependencies: 1318
-- Name: COLUMN dim_product.dpd_globalproductid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_product.dpd_globalproductid IS 'The operational global product id.';


--
-- TOC entry 1319 (class 1259 OID 16612)
-- Dependencies: 5 1318
-- Name: dim_product_dpd_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE dim_product_dpd_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.dim_product_dpd_id_seq OWNER TO postgres;

--
-- TOC entry 1757 (class 0 OID 0)
-- Dependencies: 1319
-- Name: dim_product_dpd_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE dim_product_dpd_id_seq OWNED BY dim_product.dpd_id;


--
-- TOC entry 1320 (class 1259 OID 16614)
-- Dependencies: 5
-- Name: dim_strategy; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE dim_strategy (
    dst_id integer NOT NULL,
    dst_description character varying(100),
    dst_globalid character varying(20)
);


ALTER TABLE public.dim_strategy OWNER TO postgres;

--
-- TOC entry 1758 (class 0 OID 0)
-- Dependencies: 1320
-- Name: TABLE dim_strategy; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON TABLE dim_strategy IS 'A dimension table describing a negotiation strategy. Table prefix: dst';


--
-- TOC entry 1759 (class 0 OID 0)
-- Dependencies: 1320
-- Name: COLUMN dim_strategy.dst_id; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_strategy.dst_id IS 'The table''s surrogate key.';


--
-- TOC entry 1760 (class 0 OID 0)
-- Dependencies: 1320
-- Name: COLUMN dim_strategy.dst_description; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_strategy.dst_description IS 'The description of the strategy.';


--
-- TOC entry 1761 (class 0 OID 0)
-- Dependencies: 1320
-- Name: COLUMN dim_strategy.dst_globalid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_strategy.dst_globalid IS 'The global id of the strategy described by this dimension entry.';


--
-- TOC entry 1321 (class 1259 OID 16616)
-- Dependencies: 1320 5
-- Name: dim_strategy_dst_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE dim_strategy_dst_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.dim_strategy_dst_id_seq OWNER TO postgres;

--
-- TOC entry 1762 (class 0 OID 0)
-- Dependencies: 1321
-- Name: dim_strategy_dst_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE dim_strategy_dst_id_seq OWNED BY dim_strategy.dst_id;


--
-- TOC entry 1322 (class 1259 OID 16618)
-- Dependencies: 5
-- Name: dim_template; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE dim_template (
    dtmp_id integer NOT NULL,
    dtmp_description character varying(100),
    dtmp_globalid character varying(20)
);


ALTER TABLE public.dim_template OWNER TO postgres;

--
-- TOC entry 1763 (class 0 OID 0)
-- Dependencies: 1322
-- Name: TABLE dim_template; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON TABLE dim_template IS 'A dimension table describing a negotiation template. Table prefix: dtmp';


--
-- TOC entry 1764 (class 0 OID 0)
-- Dependencies: 1322
-- Name: COLUMN dim_template.dtmp_id; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_template.dtmp_id IS 'The table''s surrogate key.';


--
-- TOC entry 1765 (class 0 OID 0)
-- Dependencies: 1322
-- Name: COLUMN dim_template.dtmp_description; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_template.dtmp_description IS 'The template''s description.';


--
-- TOC entry 1766 (class 0 OID 0)
-- Dependencies: 1322
-- Name: COLUMN dim_template.dtmp_globalid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_template.dtmp_globalid IS 'The global id of the template described by this dimension entry.';


--
-- TOC entry 1323 (class 1259 OID 16620)
-- Dependencies: 5 1322
-- Name: dim_template_dtmp_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE dim_template_dtmp_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.dim_template_dtmp_id_seq OWNER TO postgres;

--
-- TOC entry 1767 (class 0 OID 0)
-- Dependencies: 1323
-- Name: dim_template_dtmp_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE dim_template_dtmp_id_seq OWNED BY dim_template.dtmp_id;


--
-- TOC entry 1324 (class 1259 OID 16622)
-- Dependencies: 5
-- Name: dim_time; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE dim_time (
    dtm_id integer NOT NULL,
    dtm_fulltime time without time zone,
    dtm_hour smallint,
    dtm_ampmind character varying(2)
);


ALTER TABLE public.dim_time OWNER TO postgres;

--
-- TOC entry 1768 (class 0 OID 0)
-- Dependencies: 1324
-- Name: TABLE dim_time; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON TABLE dim_time IS 'A dimension table discribing time of day. Table prefix: dtm';


--
-- TOC entry 1769 (class 0 OID 0)
-- Dependencies: 1324
-- Name: COLUMN dim_time.dtm_id; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_time.dtm_id IS 'The table''s surrogate key.';


--
-- TOC entry 1770 (class 0 OID 0)
-- Dependencies: 1324
-- Name: COLUMN dim_time.dtm_hour; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_time.dtm_hour IS 'The hour part of the time (0-23)';


--
-- TOC entry 1771 (class 0 OID 0)
-- Dependencies: 1324
-- Name: COLUMN dim_time.dtm_ampmind; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_time.dtm_ampmind IS 'The AM/PM indicator. Can tak the value of ''AM'' or ''PM''. ';


--
-- TOC entry 1325 (class 1259 OID 16624)
-- Dependencies: 1324 5
-- Name: dim_time_dtm_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE dim_time_dtm_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.dim_time_dtm_id_seq OWNER TO postgres;

--
-- TOC entry 1772 (class 0 OID 0)
-- Dependencies: 1325
-- Name: dim_time_dtm_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE dim_time_dtm_id_seq OWNED BY dim_time.dtm_id;


--
-- TOC entry 1326 (class 1259 OID 16626)
-- Dependencies: 5
-- Name: dim_wholesaler_dwh_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE dim_wholesaler_dwh_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.dim_wholesaler_dwh_id_seq OWNER TO postgres;

--
-- TOC entry 1327 (class 1259 OID 16628)
-- Dependencies: 1668 5
-- Name: dim_wholesaler; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE dim_wholesaler (
    dwh_id integer DEFAULT nextval('dim_wholesaler_dwh_id_seq'::regclass) NOT NULL,
    dwh_globalid character varying(20)
);


ALTER TABLE public.dim_wholesaler OWNER TO postgres;

--
-- TOC entry 1773 (class 0 OID 0)
-- Dependencies: 1327
-- Name: TABLE dim_wholesaler; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON TABLE dim_wholesaler IS 'A dimension table descibing a wholesaler. Table prefix: dwh';


--
-- TOC entry 1774 (class 0 OID 0)
-- Dependencies: 1327
-- Name: COLUMN dim_wholesaler.dwh_id; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_wholesaler.dwh_id IS 'The table''s surrogate key.';


--
-- TOC entry 1775 (class 0 OID 0)
-- Dependencies: 1327
-- Name: COLUMN dim_wholesaler.dwh_globalid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN dim_wholesaler.dwh_globalid IS 'The operational global id of the wholesaler.';


--
-- TOC entry 1328 (class 1259 OID 16631)
-- Dependencies: 1669 5
-- Name: ft_demand; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE ft_demand (
    fdm_ddt_dateid integer NOT NULL,
    fdm_dpd_productid integer NOT NULL,
    fdm_cicquerycount integer,
    fdm_shopssellingcount integer,
    fdm_registeredclients integer DEFAULT 0
);


ALTER TABLE public.ft_demand OWNER TO postgres;

--
-- TOC entry 1776 (class 0 OID 0)
-- Dependencies: 1328
-- Name: TABLE ft_demand; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON TABLE ft_demand IS 'The fact table containing information about the demand collected from the CIC. Table prefix: fdm';


--
-- TOC entry 1777 (class 0 OID 0)
-- Dependencies: 1328
-- Name: COLUMN ft_demand.fdm_ddt_dateid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_demand.fdm_ddt_dateid IS 'The key to the date dimension entry that describes tha date when the demand has been checked.';


--
-- TOC entry 1778 (class 0 OID 0)
-- Dependencies: 1328
-- Name: COLUMN ft_demand.fdm_dpd_productid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_demand.fdm_dpd_productid IS 'The key to the product dimension entry that describes the product for which the demand was checked.';


--
-- TOC entry 1779 (class 0 OID 0)
-- Dependencies: 1328
-- Name: COLUMN ft_demand.fdm_cicquerycount; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_demand.fdm_cicquerycount IS 'The number of queries about the product sent to the cic, the day the demand was checked.';


--
-- TOC entry 1780 (class 0 OID 0)
-- Dependencies: 1328
-- Name: COLUMN ft_demand.fdm_shopssellingcount; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_demand.fdm_shopssellingcount IS 'The number of shops selling the product on the day the demand was checked. This measure is completely nonadditive, therefore care should be taken when aggregating - sum() is not safe, avg() should be alright.';


--
-- TOC entry 1781 (class 0 OID 0)
-- Dependencies: 1328
-- Name: COLUMN ft_demand.fdm_registeredclients; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_demand.fdm_registeredclients IS 'The total number of clients that registered with the GA wanting to buy the product.';


--
-- TOC entry 1329 (class 1259 OID 16634)
-- Dependencies: 5
-- Name: ft_sales; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE ft_sales (
    fsa_ddt_negoenddateid integer,
    fsa_dtm_negoendtimeid integer,
    fsa_dpd_productid integer,
    fsa_dst_strategyid integer,
    fsa_dtmp_templateid integer,
    fsa_negotiationid integer NOT NULL,
    fsa_quantityoffered integer,
    fsa_valueoffered numeric(12,2),
    fsa_minvalueoffered numeric(12,2),
    fsa_quantityreserved integer,
    fsa_valuereserved numeric(12,2),
    fsa_quantityconfirmed integer,
    fsa_valueconfirmed numeric(12,2),
    fsa_bidcount integer,
    fsa_winningbidcount integer,
    fsa_finishedtransactioncount integer
);


ALTER TABLE public.ft_sales OWNER TO postgres;

--
-- TOC entry 1782 (class 0 OID 0)
-- Dependencies: 1329
-- Name: TABLE ft_sales; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON TABLE ft_sales IS 'The sales fact table. Contains information about the sales on a per negotiation basis. Table prefix: fsa';


--
-- TOC entry 1783 (class 0 OID 0)
-- Dependencies: 1329
-- Name: COLUMN ft_sales.fsa_ddt_negoenddateid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_sales.fsa_ddt_negoenddateid IS 'The key to the date dimension entry describing the negotiation end date.';


--
-- TOC entry 1784 (class 0 OID 0)
-- Dependencies: 1329
-- Name: COLUMN ft_sales.fsa_dtm_negoendtimeid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_sales.fsa_dtm_negoendtimeid IS 'The key to the time dimension entry describing the negotiation end time.';


--
-- TOC entry 1785 (class 0 OID 0)
-- Dependencies: 1329
-- Name: COLUMN ft_sales.fsa_dpd_productid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_sales.fsa_dpd_productid IS 'The key to the product dimension entry describing the offered product.';


--
-- TOC entry 1786 (class 0 OID 0)
-- Dependencies: 1329
-- Name: COLUMN ft_sales.fsa_dst_strategyid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_sales.fsa_dst_strategyid IS 'The key to the strategy dimension entry describing the strategy used during the negotiation.';


--
-- TOC entry 1787 (class 0 OID 0)
-- Dependencies: 1329
-- Name: COLUMN ft_sales.fsa_dtmp_templateid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_sales.fsa_dtmp_templateid IS 'The key to the template dimension entry describing the template used during the negotiation.';


--
-- TOC entry 1788 (class 0 OID 0)
-- Dependencies: 1329
-- Name: COLUMN ft_sales.fsa_negotiationid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_sales.fsa_negotiationid IS 'The negotiation''s operational id.';


--
-- TOC entry 1789 (class 0 OID 0)
-- Dependencies: 1329
-- Name: COLUMN ft_sales.fsa_quantityoffered; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_sales.fsa_quantityoffered IS 'The amount of product offered for negotiation.';


--
-- TOC entry 1790 (class 0 OID 0)
-- Dependencies: 1329
-- Name: COLUMN ft_sales.fsa_valueoffered; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_sales.fsa_valueoffered IS 'The total value of the products offered for negotiation counted using the starting price.';


--
-- TOC entry 1791 (class 0 OID 0)
-- Dependencies: 1329
-- Name: COLUMN ft_sales.fsa_minvalueoffered; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_sales.fsa_minvalueoffered IS 'The total value of the product offered using the minimum price set in the negotiation strategy.';


--
-- TOC entry 1792 (class 0 OID 0)
-- Dependencies: 1329
-- Name: COLUMN ft_sales.fsa_quantityreserved; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_sales.fsa_quantityreserved IS 'The amount of product reserved after negotiation.';


--
-- TOC entry 1793 (class 0 OID 0)
-- Dependencies: 1329
-- Name: COLUMN ft_sales.fsa_valuereserved; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_sales.fsa_valuereserved IS 'The total value of the products reserved after the negotiation.';


--
-- TOC entry 1794 (class 0 OID 0)
-- Dependencies: 1329
-- Name: COLUMN ft_sales.fsa_quantityconfirmed; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_sales.fsa_quantityconfirmed IS 'The amount of product confirmed by the buyers and considered sold.';


--
-- TOC entry 1795 (class 0 OID 0)
-- Dependencies: 1329
-- Name: COLUMN ft_sales.fsa_valueconfirmed; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_sales.fsa_valueconfirmed IS 'The total value of the products confirmed by the buyers and considered sold.';


--
-- TOC entry 1796 (class 0 OID 0)
-- Dependencies: 1329
-- Name: COLUMN ft_sales.fsa_bidcount; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_sales.fsa_bidcount IS 'The number of bids during the negotiation.';


--
-- TOC entry 1797 (class 0 OID 0)
-- Dependencies: 1329
-- Name: COLUMN ft_sales.fsa_winningbidcount; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_sales.fsa_winningbidcount IS 'The number of winning bids.';


--
-- TOC entry 1798 (class 0 OID 0)
-- Dependencies: 1329
-- Name: COLUMN ft_sales.fsa_finishedtransactioncount; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_sales.fsa_finishedtransactioncount IS 'The number of finished transactions  following this negotiation, that is the reservations that ended up either confirmed, cancelled or expired.';


--
-- TOC entry 1330 (class 1259 OID 16636)
-- Dependencies: 5
-- Name: ft_salesforecasts; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE ft_salesforecasts (
    fsf_ddt_startdateid integer NOT NULL,
    fsf_ddt_enddateid integer NOT NULL,
    fsf_quantity real,
    fsf_deviation real,
    fsf_dpd_productid integer NOT NULL
);


ALTER TABLE public.ft_salesforecasts OWNER TO postgres;

--
-- TOC entry 1331 (class 1259 OID 16638)
-- Dependencies: 5
-- Name: ft_supplies; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE ft_supplies (
    fsp_dwh_wholesalerid integer,
    fsp_dpd_productid integer,
    fsp_ddt_orderdateid integer,
    fsp_dtm_ordertimeid integer,
    fsp_ddt_deliverydateid integer,
    fsp_dtm_deliverytimeid integer,
    fsp_quantityordered integer,
    fsp_valueordered numeric(12,2),
    fsp_quantitydelivered integer,
    fsp_valuedelivered numeric(12,2)
);


ALTER TABLE public.ft_supplies OWNER TO postgres;

--
-- TOC entry 1799 (class 0 OID 0)
-- Dependencies: 1331
-- Name: TABLE ft_supplies; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON TABLE ft_supplies IS 'The fact table containing information about product supplies from wholesalers. Table prefix: fsp';


--
-- TOC entry 1800 (class 0 OID 0)
-- Dependencies: 1331
-- Name: COLUMN ft_supplies.fsp_dwh_wholesalerid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_supplies.fsp_dwh_wholesalerid IS 'The id of the wholesaler dimension entry describing the wholesaler who handled this order.';


--
-- TOC entry 1801 (class 0 OID 0)
-- Dependencies: 1331
-- Name: COLUMN ft_supplies.fsp_dpd_productid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_supplies.fsp_dpd_productid IS 'The key to the product dimension entry describing the product delivered.';


--
-- TOC entry 1802 (class 0 OID 0)
-- Dependencies: 1331
-- Name: COLUMN ft_supplies.fsp_ddt_orderdateid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_supplies.fsp_ddt_orderdateid IS 'The key to the date dimension entry describing the date of the making of the order.';


--
-- TOC entry 1803 (class 0 OID 0)
-- Dependencies: 1331
-- Name: COLUMN ft_supplies.fsp_dtm_ordertimeid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_supplies.fsp_dtm_ordertimeid IS 'The key to the time dimension entry describing the time of day of the making of the order.';


--
-- TOC entry 1804 (class 0 OID 0)
-- Dependencies: 1331
-- Name: COLUMN ft_supplies.fsp_ddt_deliverydateid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_supplies.fsp_ddt_deliverydateid IS 'The key to the date dimension entry describing the date the ordered product was delivered.';


--
-- TOC entry 1805 (class 0 OID 0)
-- Dependencies: 1331
-- Name: COLUMN ft_supplies.fsp_dtm_deliverytimeid; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_supplies.fsp_dtm_deliverytimeid IS 'The key to the time dimension entry describing the time of day when the ordered product was delivered.';


--
-- TOC entry 1806 (class 0 OID 0)
-- Dependencies: 1331
-- Name: COLUMN ft_supplies.fsp_quantityordered; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_supplies.fsp_quantityordered IS 'The amount of product ordered.';


--
-- TOC entry 1807 (class 0 OID 0)
-- Dependencies: 1331
-- Name: COLUMN ft_supplies.fsp_valueordered; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_supplies.fsp_valueordered IS 'The total value of the product ordered using the ordering price.';


--
-- TOC entry 1808 (class 0 OID 0)
-- Dependencies: 1331
-- Name: COLUMN ft_supplies.fsp_quantitydelivered; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_supplies.fsp_quantitydelivered IS 'The amount of product delivered by the wholesaler.';


--
-- TOC entry 1809 (class 0 OID 0)
-- Dependencies: 1331
-- Name: COLUMN ft_supplies.fsp_valuedelivered; Type: COMMENT; Schema: public; Owner: postgres
--

COMMENT ON COLUMN ft_supplies.fsp_valuedelivered IS 'The total value of the delivered product using the delivery price.';


--
-- TOC entry 1662 (class 2604 OID 16755)
-- Dependencies: 1315 1314
-- Name: dbu_id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE dim_buyer ALTER COLUMN dbu_id SET DEFAULT nextval('dim_buyer_dbu_id_seq'::regclass);


--
-- TOC entry 1663 (class 2604 OID 16756)
-- Dependencies: 1317 1316
-- Name: ddt_id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE dim_date ALTER COLUMN ddt_id SET DEFAULT nextval('dim_date_ddt_id_seq'::regclass);


--
-- TOC entry 1664 (class 2604 OID 16757)
-- Dependencies: 1319 1318
-- Name: dpd_id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE dim_product ALTER COLUMN dpd_id SET DEFAULT nextval('dim_product_dpd_id_seq'::regclass);


--
-- TOC entry 1665 (class 2604 OID 16758)
-- Dependencies: 1321 1320
-- Name: dst_id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE dim_strategy ALTER COLUMN dst_id SET DEFAULT nextval('dim_strategy_dst_id_seq'::regclass);


--
-- TOC entry 1666 (class 2604 OID 16759)
-- Dependencies: 1323 1322
-- Name: dtmp_id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE dim_template ALTER COLUMN dtmp_id SET DEFAULT nextval('dim_template_dtmp_id_seq'::regclass);


--
-- TOC entry 1667 (class 2604 OID 16760)
-- Dependencies: 1325 1324
-- Name: dtm_id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE dim_time ALTER COLUMN dtm_id SET DEFAULT nextval('dim_time_dtm_id_seq'::regclass);


--
-- TOC entry 1692 (class 2606 OID 16647)
-- Dependencies: 1330 1330 1330 1330
-- Name: fsf_pk_dateproduct; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY ft_salesforecasts
    ADD CONSTRAINT fsf_pk_dateproduct PRIMARY KEY (fsf_ddt_startdateid, fsf_ddt_enddateid, fsf_dpd_productid);


--
-- TOC entry 1671 (class 2606 OID 16649)
-- Dependencies: 1314 1314
-- Name: pk_dbu_id; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY dim_buyer
    ADD CONSTRAINT pk_dbu_id PRIMARY KEY (dbu_id);


--
-- TOC entry 1673 (class 2606 OID 16651)
-- Dependencies: 1316 1316
-- Name: pk_ddt_id; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY dim_date
    ADD CONSTRAINT pk_ddt_id PRIMARY KEY (ddt_id);


--
-- TOC entry 1676 (class 2606 OID 16653)
-- Dependencies: 1318 1318
-- Name: pk_dpd_id; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY dim_product
    ADD CONSTRAINT pk_dpd_id PRIMARY KEY (dpd_id);


--
-- TOC entry 1678 (class 2606 OID 16655)
-- Dependencies: 1320 1320
-- Name: pk_dst_id; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY dim_strategy
    ADD CONSTRAINT pk_dst_id PRIMARY KEY (dst_id);


--
-- TOC entry 1682 (class 2606 OID 16657)
-- Dependencies: 1324 1324
-- Name: pk_dtm_id; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY dim_time
    ADD CONSTRAINT pk_dtm_id PRIMARY KEY (dtm_id);


--
-- TOC entry 1680 (class 2606 OID 16659)
-- Dependencies: 1322 1322
-- Name: pk_dtmp_id; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY dim_template
    ADD CONSTRAINT pk_dtmp_id PRIMARY KEY (dtmp_id);


--
-- TOC entry 1685 (class 2606 OID 16661)
-- Dependencies: 1327 1327
-- Name: pk_dwh_id; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY dim_wholesaler
    ADD CONSTRAINT pk_dwh_id PRIMARY KEY (dwh_id);


--
-- TOC entry 1687 (class 2606 OID 16663)
-- Dependencies: 1328 1328 1328
-- Name: pk_fdm_date_product; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY ft_demand
    ADD CONSTRAINT pk_fdm_date_product PRIMARY KEY (fdm_ddt_dateid, fdm_dpd_productid);


--
-- TOC entry 1689 (class 2606 OID 16665)
-- Dependencies: 1329 1329
-- Name: pk_fsa_negotiationid; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY ft_sales
    ADD CONSTRAINT pk_fsa_negotiationid PRIMARY KEY (fsa_negotiationid);


--
-- TOC entry 1674 (class 1259 OID 16666)
-- Dependencies: 1316
-- Name: uq_ddt_fulldate; Type: INDEX; Schema: public; Owner: postgres; Tablespace: 
--

CREATE UNIQUE INDEX uq_ddt_fulldate ON dim_date USING btree (ddt_fulldate);


--
-- TOC entry 1683 (class 1259 OID 16667)
-- Dependencies: 1324
-- Name: uq_dtm_fulltime; Type: INDEX; Schema: public; Owner: postgres; Tablespace: 
--

CREATE UNIQUE INDEX uq_dtm_fulltime ON dim_time USING btree (dtm_fulltime);


--
-- TOC entry 1690 (class 1259 OID 16668)
-- Dependencies: 1329
-- Name: uq_fsa_negotiationid; Type: INDEX; Schema: public; Owner: postgres; Tablespace: 
--

CREATE UNIQUE INDEX uq_fsa_negotiationid ON ft_sales USING btree (fsa_negotiationid);


--
-- TOC entry 1693 (class 2606 OID 16669)
-- Dependencies: 1328 1316 1672
-- Name: fk_fdm_ddt_date; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY ft_demand
    ADD CONSTRAINT fk_fdm_ddt_date FOREIGN KEY (fdm_ddt_dateid) REFERENCES dim_date(ddt_id);


--
-- TOC entry 1694 (class 2606 OID 16674)
-- Dependencies: 1318 1328 1675
-- Name: fk_fdm_dpd_product; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY ft_demand
    ADD CONSTRAINT fk_fdm_dpd_product FOREIGN KEY (fdm_dpd_productid) REFERENCES dim_product(dpd_id);


--
-- TOC entry 1695 (class 2606 OID 16679)
-- Dependencies: 1672 1316 1329
-- Name: fk_fsa_ddt_negoend; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY ft_sales
    ADD CONSTRAINT fk_fsa_ddt_negoend FOREIGN KEY (fsa_ddt_negoenddateid) REFERENCES dim_date(ddt_id);


--
-- TOC entry 1696 (class 2606 OID 16684)
-- Dependencies: 1675 1318 1329
-- Name: fk_fsa_dpd_product; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY ft_sales
    ADD CONSTRAINT fk_fsa_dpd_product FOREIGN KEY (fsa_dpd_productid) REFERENCES dim_product(dpd_id);


--
-- TOC entry 1697 (class 2606 OID 16689)
-- Dependencies: 1320 1677 1329
-- Name: fk_fsa_dst_strategy; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY ft_sales
    ADD CONSTRAINT fk_fsa_dst_strategy FOREIGN KEY (fsa_dst_strategyid) REFERENCES dim_strategy(dst_id);


--
-- TOC entry 1698 (class 2606 OID 16694)
-- Dependencies: 1681 1329 1324
-- Name: fk_fsa_dtm_negoendtime; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY ft_sales
    ADD CONSTRAINT fk_fsa_dtm_negoendtime FOREIGN KEY (fsa_dtm_negoendtimeid) REFERENCES dim_time(dtm_id);


--
-- TOC entry 1699 (class 2606 OID 16699)
-- Dependencies: 1329 1679 1322
-- Name: fk_fsa_dtmp_template; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY ft_sales
    ADD CONSTRAINT fk_fsa_dtmp_template FOREIGN KEY (fsa_dtmp_templateid) REFERENCES dim_template(dtmp_id);


--
-- TOC entry 1700 (class 2606 OID 16704)
-- Dependencies: 1331 1672 1316
-- Name: fk_fsp_ddt_deliverydate; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY ft_supplies
    ADD CONSTRAINT fk_fsp_ddt_deliverydate FOREIGN KEY (fsp_ddt_deliverydateid) REFERENCES dim_date(ddt_id);


--
-- TOC entry 1701 (class 2606 OID 16709)
-- Dependencies: 1672 1316 1331
-- Name: fk_fsp_ddt_orderdate; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY ft_supplies
    ADD CONSTRAINT fk_fsp_ddt_orderdate FOREIGN KEY (fsp_ddt_orderdateid) REFERENCES dim_date(ddt_id);


--
-- TOC entry 1702 (class 2606 OID 16714)
-- Dependencies: 1675 1318 1331
-- Name: fk_fsp_dpd_product; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY ft_supplies
    ADD CONSTRAINT fk_fsp_dpd_product FOREIGN KEY (fsp_dpd_productid) REFERENCES dim_product(dpd_id);


--
-- TOC entry 1703 (class 2606 OID 16719)
-- Dependencies: 1331 1681 1324
-- Name: fk_fsp_dtm_deliverytime; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY ft_supplies
    ADD CONSTRAINT fk_fsp_dtm_deliverytime FOREIGN KEY (fsp_dtm_deliverytimeid) REFERENCES dim_time(dtm_id);


--
-- TOC entry 1704 (class 2606 OID 16724)
-- Dependencies: 1331 1324 1681
-- Name: fk_fsp_dtm_ordertime; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY ft_supplies
    ADD CONSTRAINT fk_fsp_dtm_ordertime FOREIGN KEY (fsp_dtm_ordertimeid) REFERENCES dim_time(dtm_id);


--
-- TOC entry 1705 (class 2606 OID 16729)
-- Dependencies: 1331 1684 1327
-- Name: fk_fsp_dwh_wholesaler; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY ft_supplies
    ADD CONSTRAINT fk_fsp_dwh_wholesaler FOREIGN KEY (fsp_dwh_wholesalerid) REFERENCES dim_wholesaler(dwh_id);


--
-- TOC entry 1710 (class 0 OID 0)
-- Dependencies: 5
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


-- Completed on 2008-01-07 02:09:28

--
-- PostgreSQL database dump complete
--

