package ibspan.ecap.merchant.shopdecisions;

import java.util.logging.Level;

import ibspan.ecap.merchant.shopdecisions.dataadministration.DataAccessException;
import ibspan.ecap.merchant.shopdecisions.dataadministration.DataAdministrationModule;
import ibspan.ecap.merchant.shopdecisions.dataadministration.FinalisationType;
import ibspan.ecap.merchant.shopdecisions.dataadministration.TransactionLog;
import ibspan.ecap.shared.ontology.negotiation.NegotiationLog;
import jade.core.Agent;
import jade.core.behaviours.OneShotBehaviour;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.UnreadableException;
import jade.util.Logger;

public class RecordNegotiationHandler extends OneShotBehaviour
{
	public static final String MESSAGE_KEY = "MessageKey";
	protected Logger myLogger = Logger.getMyLogger(this.getClass().getName());
	
	public RecordNegotiationHandler(Agent myAgent)
	{
		super(myAgent);
	}

	@Override
	public void action()
	{
//		ACLMessage message = (ACLMessage) getDataStore().get(RecordNegotiationHandler.MESSAGE_KEY);
//		
//		if(message == null)
//		{
//			myLogger.warning("RecordNegotiationHandler didn't receive a message"); 
//			return;
//		}
//		NegotiationLog log;
//		try
//		{
//			log = retrieveLog(message);
//		} catch (UnreadableException e)
//		{
//			myLogger.warning("RecordNegotiationHandler couldn't retrieve content from the message"); 
//			return;
//		} catch (ClassCastException e)
//		{
//			myLogger.warning("RecordNegotiationHandler received wrong content in the message"); 
//			return;
//		}
//		
//		try
//		{
//			DataAdministrationModule.getInstance().recordNegotiationDetails(log);
//			//TODO: Disable test scenario modification
//			//simulateTransactionDetails(log);			
//		} catch (DataAccessException e)
//		{
//			myLogger.log(Level.WARNING, "RecordNegotiationHandler failed to record negotiation data.", e);
//			return;
//		}
		
		ACLMessage message = (ACLMessage) getDataStore().get(RecordNegotiationHandler.MESSAGE_KEY);
		
		if(message == null)
		{
			myLogger.warning("RecordNegotiationHandler didn't receive a message"); 
			return;
		}
		NegotiationLog[] logs;
		try
		{
			logs = retrieveLog(message);
		} catch (UnreadableException e)
		{
			myLogger.warning("RecordNegotiationHandler couldn't retrieve content from the message"); 
			return;
		} catch (ClassCastException e)
		{
			myLogger.warning("RecordNegotiationHandler received wrong content in the message"); 
			return;
		}
		
		myLogger.info("Received nego logs. Size:"+logs.length);
		for (NegotiationLog log : logs) {
			try
			{
				DataAdministrationModule.getInstance().recordNegotiationDetails(log);
				//TODO: Disable test scenario modification
				//simulateTransactionDetails(log);			
			} catch (DataAccessException e)
			{
				myLogger.log(Level.WARNING, "RecordNegotiationHandler failed to record negotiation data.", e);
				return;
			}	
		}
		
	}

	//TODO: Remove test scenario modification
//	private void simulateTransactionDetails(NegotiationLog log)
//	{
//		TransactionLog tl = new TransactionLog();
//		tl.setClientId("test");
//		tl.setFinalisationType(FinalisationType.CONFIRMED);
//		//TODO: Check if working correctly
//		tl.setNegotiationId(log.getNegotiationId());
//		//tl.setQuantityReserved(log.get)
//		
//	}

//	private NegotiationLog retrieveLog(ACLMessage message) throws UnreadableException
//	{
//		NegotiationLog log = (NegotiationLog) message.getContentObject();
//		return log;
//	}
	
	private NegotiationLog[] retrieveLog(ACLMessage message) throws UnreadableException
	{
		NegotiationLog[] log = (NegotiationLog[]) message.getContentObject();
		return log;
	}

}
