package ibspan.ecap.merchant.shopdecisions.dataaccess.tests;

import ibspan.ecap.merchant.shopdecisions.dataadministration.BuyerRegistrationInfo;
import ibspan.ecap.merchant.shopdecisions.dataadministration.DataAccessException;
import ibspan.ecap.merchant.shopdecisions.dataadministration.DataAdministrationModule;
import ibspan.ecap.shared.ontology.negotiation.DemandData;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

public class DemandDataImporter
{
	public void importDemandData(String filePath) throws IOException, DataAccessException
	{
		DataAdministrationModule dam = DataAdministrationModule.getInstance();
		FileReader rd = new FileReader(filePath);
		BufferedReader br = new BufferedReader(rd);
		String line;
		Calendar cal = new GregorianCalendar(2006, 0, 1);
		
		while((line = br.readLine()) != null)
		{
			String regex = "\t";
			String[] params = line.split(regex);
			//System.out.printf("Line: %1$s", line);
			System.out.printf("Demand: %1$s; Shops: %2$s; Clients: %3$s\n", params[0], params[1], params[2]);
			int cicQueries = Integer.parseInt(params[0]);
			int shops = Integer.parseInt(params[1]);
			int clients = Integer.parseInt(params[2]);
			DemandData data = new DemandData();
			data.setCicQueryCount(cicQueries);
			data.setShopsSellingProductCount(shops);			
			data.setGlobalProductId("Blender ZX-2010-UDPA");
			data.setWhen(cal.getTime());
			data.setRegisteredClients(clients);
			cal.add(Calendar.DATE, 1);
			
			dam.recordDemandData(data);
			
		}
	}
}
