package ibspan.ecap.merchant.shopdecisions.dataadministration;

import java.io.Serializable;
import java.util.Date;

/**
 * A class containing information about a registration of a buyer agent with the GA.
 * 
 * @author Micha Drozdowicz
 */
public class BuyerRegistrationInfo implements Serializable
{
	private String clientId;
	private String productId;
	private Date registrationTime;
	private boolean isCreatedByShop;
	
	/**
	 * Gets the id of the client the buyer belongs to.
	 * 
	 * @return the id of the client the buyer belongs to
	 */
	public String getClientId()
	{
		return clientId;
	}
	
	/**
	 * Sets the id of the client the buyer belongs to
	 * 
	 * @param clientId the id of the client the buyer belongs to
	 */
	public void setClientId(String clientId)
	{
		this.clientId = clientId;
	}
	
	/**
	 * Gets the id of the product the buyer wanted to buy
	 * 
	 * @return the id of the product the buyer wanted to buy
	 */
	public String getProductId()
	{
		return productId;
	}
	
	/**
	 * Sets the id of the product the buyer wanted to buy
	 * 
	 * @param productId the id of the product the buyer wanted to buy
	 */
	public void setProductId(String productId)
	{
		this.productId = productId;
	}
	
	/**
	 * Gets the registration time.
	 * 
	 * @return the registration time
	 */
	public Date getRegistrationTime()
	{
		return registrationTime;
	}
	
	/**
	 * Sets the registration time.
	 * 
	 * @param registrationTime the new registration time
	 */
	public void setRegistrationTime(Date registrationTime)
	{
		this.registrationTime = registrationTime;
	}
	
	/**
	 * Checks if the buyer agent was created by shop.
	 * 
	 * @return true, if the buyer agent was created by shop.
	 */
	public boolean isCreatedByShop()
	{
		return isCreatedByShop;
	}
	
	/**
	 * Sets if the buyer agent was created by shop.
	 * 
	 * @param isCreatedByShop true if the buyer agent was created by shop.
	 */
	public void setCreatedByShop(boolean isCreatedByShop)
	{
		this.isCreatedByShop = isCreatedByShop;
	}
	
	
}
