package ibspan.ecap.merchant.shopdecisions.forecasting;

import java.util.Date;

import net.sourceforge.openforecast.DataPoint;
import net.sourceforge.openforecast.DataSet;
import net.sourceforge.openforecast.Observation;
import net.sourceforge.openforecast.input.Builder;
import net.sourceforge.openforecast.input.CSVBuilder;

public class FileDataProvider implements DataProvider
{

	public DataSet getHistoricalData(String productId, Date startDate,
			int periodLength) throws Exception
	{
		String fileName = productId + ".csv";
		Builder builder = new CSVBuilder(fileName, true);
		
		DataSet data = builder.build();
		data.setPeriodsPerYear(365/periodLength);
		data.setTimeVariable("t");
		
		return data;
	}

	public DataPoint getFuturePoint(String productId, Date startDate,
			int periodLength, DataSet historicalData)
	{
		int nextPeriodNumber = historicalData.size();
				
		DataPoint point = new Observation(0.0);
		point.setIndependentValue("t", nextPeriodNumber);
		return point;
	}

}
