package ibspan.ecap.merchant.shopdecisions.forecasting;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

public class FixedHorizonEstimator implements HorizonEstimator
{

	private int defaultHorizonLength;

	private Map<String, Integer> horizons = new HashMap<String, Integer>();

	public FixedHorizonEstimator(int defaultHorizonLength)
	{
		this.defaultHorizonLength = defaultHorizonLength;
	}

	public void setProductHorizon(String productId, int horizonLength)
	{
		horizons.put(productId, horizonLength);
	}

	public int estimateHorizon(String productId, Date forecastStart)
	{			
		if (horizons.containsKey(productId))
			return horizons.get(productId);
		else
			return defaultHorizonLength;
	}

}
