package ibspan.ecap.merchant.shopdecisions.forecasting;

import java.io.Serializable;
import java.util.Date;


/**
 * A class describing a forecast.
 * @author  Michal
 */
public class ForecastDescription implements Serializable
{
	private String productId;

	private int forecastPeriod;

	private float forecastAmount;

	private float forecastDeviation;
	
	private java.util.Date preparationTime;

	public ForecastDescription(String productId, int forecastPeriod,
			float forecastAmount, float forecastDeviation, Date preparationTime)
	{
		this.productId = productId;
		this.forecastPeriod = forecastPeriod;
		this.forecastAmount = forecastAmount;
		this.forecastDeviation = forecastDeviation;
		this.preparationTime = preparationTime;
	}

	public float getForecastAmount()
	{
		return forecastAmount;
	}

	public float getForecastDeviation()
	{
		return forecastDeviation;
	}

	public int getForecastPeriod()
	{
		return forecastPeriod;
	}

	public String getProductId()
	{
		return productId;
	}

	public java.util.Date getPreparationTime()
	{
		return preparationTime;
	}

	public void setPreparationTime(java.util.Date preparationTime)
	{
		this.preparationTime = preparationTime;
	}

	@Override
	public String toString() {
		return String.format("ForecastDescription: {\n" +
				"\tproductId: %s\n" +
				"\tforecastPeriod: %s\n" +
				"\tforecastAmount: %s\n" +
				"\tforecastDeviation: %s\n" +
				"\tpreparationTime: %s\n" +
				"}\n", 
				productId, forecastPeriod, forecastAmount, forecastDeviation,
				preparationTime);
	}
}
