package ibspan.ecap.shared.util;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

public class DateTool
{
	private static long epochStart = new GregorianCalendar(1990, 0, 1, 0, 0, 0).getTimeInMillis();
	private static long millisInDay = 1000 * 60 * 60 * 24;
	
	public static String getWeekdayIndicator(Calendar calendar)
	{		
		int dayOfWeek = calendar.get(Calendar.DAY_OF_WEEK);		
		if( dayOfWeek == Calendar.SATURDAY || dayOfWeek == Calendar.SUNDAY)
			return "Weekend";
		else
			return "Weekday";
	}

	public static String getDayOfWeekName(int dayInWeek)
	{	
		switch (dayInWeek)
		{
		case Calendar.MONDAY:
			return "Monday";
		case Calendar.TUESDAY:
			return "Tuesday";
		case Calendar.WEDNESDAY:
			return "Wednesday";
		case Calendar.THURSDAY:
			return "Thursday";
		case Calendar.FRIDAY:
			return "Friday";
		case Calendar.SATURDAY:
			return "Saturday";
		case Calendar.SUNDAY:
			return "Sunday";
		}
				
		return null;		
	}
	
	public static int getDayOfWeek(int i)
	{
		switch (i)
		{
		case Calendar.MONDAY:
			return 1;
		case Calendar.TUESDAY:
			return 2;
		case Calendar.WEDNESDAY:
			return 3;
		case Calendar.THURSDAY:
			return 4;
		case Calendar.FRIDAY:
			return 5;
		case Calendar.SATURDAY:
			return 6;
		case Calendar.SUNDAY:
			return 7;
		}
		throw new RuntimeException("Invalid input.");
	}
	
	public static int getDayInEpoch(Date date)
	{		
		Calendar calendar = GregorianCalendar.getInstance();
		calendar.setTime(date);

		calendar.set(Calendar.HOUR_OF_DAY, 12);
		calendar.set(Calendar.MINUTE, 0);
		calendar.set(Calendar.SECOND, 0);
		calendar.set(Calendar.MILLISECOND, 0);
		
		long millis = calendar.getTimeInMillis();
		return (int) (millis/millisInDay);
	}
	
	public static int getMonthInEpoch(Calendar cal)
	{
		int years = cal.get(Calendar.YEAR) - 1970;
		
		return years * 12 + cal.get(Calendar.MONTH);
	}
	
	public static int getWeekInEpoch(Date date)
	{
		return getDayInEpoch(date) / 7 + 1;
	}
}
